#ifndef CONFIG_H_IN
#define CONFIG_H_IN


/* версия ltrd */
#define LTRD_VERSION_MAJOR 2
#define LTRD_VERSION_MINOR 1
#define LTRD_VERSION_REV   1
#define LTRD_VERSION_PATCH 0


#define LTRD_PROGRAMM_NAME "ltrd"
#define LTRD_CRATE_NAME    "LTR"
#define LTR_MODULE_NAME    "LTR"

/* проверка наличия в системе нужных функций и файлов */

/* наличие библиотеки libdaemon */
/* #undef HAVE_LIBDAEMON */
/* наличие функции strlen */
/* #undef HAVE_STRNLEN */
/* наличие файла string.h */
#define HAVE_STRING_H 1
/* наличие libmxl2 */
#define HAVE_LIBXML2 1
/* наличие int64_t */
#define HAVE_INT64   1
/* наличие uint64_t */
#define HAVE_UINT64   1
/* наличие функции initgroups */
#define HAVE_INITGROUPS  1
/* наличие структуры sockaddr_in6 */
#define HAVE_SOCKADDR_IN6 1
/* наличие типа socklen_t */
#define HAVE_SOCKLEN_T 1
/* наличие файла ifaddrs.h */
#define HAVE_IFADDRS_H 1
/* наличие sys/timers.h */
/* #undef HAVE_SYS_TIMERS_H */
/* наличие типа клока CLOCK_MONOTONIC */
#define HAVE_CLOCK_MONOTONIC 1
/* наличие libusb_error_name() при включенной поддержке libusb */
/* #undef HAVE_LIBUSB_ERROR_NAME */









#ifndef HAVE_STRLEN
    #ifdef HAVE_STRING_H
        #include <string.h>
    #endif
    size_t strnlen(const char *s, size_t maxlen);
#endif

#include "stdint.h"

#ifndef HAVE_UINT64

    typedef struct
    {
        uint32_t l;
        uint32_t h;
    } uint64_t;

#define UINT64_INC(val) \
    do {\
        if (val.l!=UINT32_MAX) \
            val.l = val.l + 1; \
        else \
        { \
            val.l = 0; \
            val.h = val.h+1; \
        } \
    } while (0)

#define UINT64_ADD32(val, add) \
    do {\
        uint32_t delta = (UINT32_MAX-val.l); \
        if (delta >= (uint32_t)add) \
            val.l = val.l + add; \
        else \
        { \
            val.l = add-delta-1; \
            val.h = val.h+1; \
        } \
    } while (0)

#define UINT64_ASSIGN32(dst, src) \
    do { \
        dst.l = src; \
        dst.h = 0; \
    } while(0)

#define UINT64_OR(val, high, low) \
    do { \
        (val).l |= (low); \
        (val).h |= (high); \
    } while(0)

#define UINT64_LOW(val)   val.l
#define UINT64_HIGH(val)  val.h

#define UINT64_IS_ZERO(val) ((val.l==0) && (val.h==0))



#else
    #define UINT64_INC(val)             val++
    #define UINT64_ADD32(val, add)      val+=add
    #define UINT64_ASSIGN32(dst, src)   dst = src
    #define UINT64_OR(val, h, l)        (val = val | (((uint64_t)(h)) << 32) | (uint64_t)(l))
    #define UINT64_LOW(val)             (val & 0xFFFFFFFF)
    #define UINT64_HIGH(val)            ((val >> 32) & 0xFFFFFFFF)
    #define UINT64_IS_ZERO(val)         (val==0)
#endif


/* включение-выключение опций */

/* При разрешении этой опции включается код для запуска ltrd в режиме
 * демона (отключаеся от консоли, закрывает все хендлы и т.д.) при передаче
 * ключа --daemon */
/* #undef LTRD_DAEMON_ENABLED */

/* При включении этой опции разрешается вывод на stdout (если ltrd был запущен
   без ключа --daemon) */
#define LTRD_STDOUT_ENABLED

/* При включении этой опции разрешается вывод в системный лог либо
 * с помощью syslog() или через daemon_log() */
#define LTRD_SYSLOG_ENABLED

/* Включение поддержки режима работы с systemd */
/* #undef LTRD_SYSTEMD_ENABLED */

/* Включение кода рассчета статистики скорости передачи */
#define LTRD_BAND_STATISTIC_ENABLED

/* Включение поддержки USB */
/* #undef LTRD_USB_ENABLED */

/* Поддуржка API для получения лога сервера */
#define LTRD_LOGPROTO_ENABLED



/* файл с прошивкой ПЛИС для LTR-U-8/16 (LTR010) */
#define LTRD_LTR010_FIRMWARE_FILE "/usr/share/ltrd/firmware/ltr010v3_0_5.ttf"

#endif // CONFIG_H_IN
