
cmake_policy(PUSH)

cmake_minimum_required(VERSION 2.6)

include(CheckLibraryExists)


set (TIMER_HEADERS ${LTRAPI_MODULE_HEADERS}
     ${LTRAPI_LIB_DIR}/timer/timer.h
     ${LTRAPI_LIB_DIR}/lcspec/lcspec.h
    )



if(UNIX)
    set(TIMER_SOURCES ${LTRAPI_LIB_DIR}/timer/ports/linux/clock.c)
    include_directories(${LTRAPI_LIB_DIR}/timer/ports/linux)
elseif(WIN32)
    set(TIMER_SOURCES ${LTRAPI_LIB_DIR}/timer/ports/win/clock.c)
    include_directories(${LTRAPI_LIB_DIR}/timer/ports/win)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "QNX4")
    set(TIMER_SOURCES ${LTRAPI_LIB_DIR}/timer/ports/linux/clock.c)
    include_directories(${LTRAPI_LIB_DIR}/timer/ports/linux)
endif(UNIX)

include_directories(${LTRAPI_LIB_DIR}/lcspec ${LTRAPI_LIB_DIR}/timer)

if(UNIX)
    check_library_exists(rt clock_gettime "" HAVE_LIBRT)
    if(${HAVE_LIBRT})
        set(TIMER_LIBS ${TIMER_LIBS} rt)
    endif(${HAVE_LIBRT})
endif(UNIX)

cmake_policy(POP)
