unit ltr51api;
interface
uses windows, SysUtils, ltrapitypes, ltrapidefine, ltrapi;
const
    //    .    
    LTR51_BASE_VAL_MIN        = 70;
    //      
    LTR51_FS_MAX              = 500000;
    // .    
    LTR51_CHANNEL_CNT         = 16;

    LTR51_THRESHOLD_RANGE_1_2V = 1;
    LTR51_THRESHOLD_RANGE_10V  = 0;

    LTR51_EDGE_MODE_RISE      = 0;
    LTR51_EDGE_MODE_FALL      = 1;








    //  
    LTR51_NO_ERR                            =0;
    LTR51_ERR_WRONG_MODULE_DESCR            =-5001;
    LTR51_ERR_CANT_OPEN                     =-5002;
    LTR51_ERR_CANT_LOAD_ALTERA              =-5003;
    LTR51_ERR_INVALID_CRATE_SN              =-5004;
    LTR51_ERR_INVALID_SLOT_NUM              =-5005;
    LTR51_ERR_CANT_SEND_COMMAND             =-5006;
    LTR51_ERR_CANT_RESET_MODULE             =-5007;
    LTR51_ERR_MODULE_NO_RESPONCE            =-5008;
    LTR51_ERR_CANT_OPEN_MODULE              =-5009;
    LTR51_ERR_PARITY_TO_MODULE              =-5010;
    LTR51_ERR_PARITY_FROM_MODULE            =-5011;
    LTR51_ERR_ALTERA_TEST_FAILED            =-5012;
    LTR51_ERR_CANT_START_DATA_AQC           =-5013;
    LTR51_ERR_CANT_STOP_DATA_AQC            =-5014;
    LTR51_ERR_CANT_SET_FS                   =-5015;
    LTR51_ERR_CANT_SET_BASE                 =-5016;
    LTR51_ERR_CANT_SET_EDGE_MODE            =-5017;
    LTR51_ERR_CANT_SET_THRESHOLD            =-5018;
    LTR51_WRONG_DATA                        =-5019;
    LTR51_ERR_WRONG_HIGH_THRESOLD_SETTINGS  =-5020;
    LTR51_ERR_WRONG_LOW_THRESOLD_SETTINGS   =-5021;
    LTR51_ERR_WRONG_FPGA_FILE               =-5022;
    LTR51_ERR_CANT_READ_ID_REC              =-5023;
    LTR51_ERR_WRONG_ID_REC                  =-5024;
    LTR51_ERR_WRONG_FS_SETTINGS             =-5025;
    LTR51_ERR_WRONG_BASE_SETTINGS           =-5026;
    LTR51_ERR_CANT_WRITE_EEPROM             =-5027;
    LTR51_ERR_CANT_READ_EEPROM              =-5028;
    LTR51_ERR_WRONG_EEPROM_ADDR             =-5029;
    LTR51_ERR_WRONG_THRESHOLD_VALUES        =-5030;
    LTR51_ERR_ERROR_OVERFLOW                =-5031;
    LTR51_ERR_MODULE_WRONG_ACQ_TIME_SETTINGS=-5032;
    LTR51_ERR_NOT_ENOUGH_POINTS             =-5033;
    LTR51_ERR_WRONG_SRC_SIZE                =-5034;

//   
type

    {$A4}
    TINFO_LTR51=record
        Name:           array[0..15] of AnsiChar;
        Serial:         array[0..23] of AnsiChar;
        FirmwareVersion:array[0..7]  of AnsiChar; //   AVR
        FirmwareDate:   array[0..15] of AnsiChar; //      AVR
        FPGA_Version:   array[0..7]  of AnsiChar; //   
    end;

    PTINFO_LTR51=^TINFO_LTR51;

    TLTR51 = record
        size:       integer;              //  
        Channel:    TLTR;
        ChannelsEna:WORD;          //    (,   .)
        SetUserPars:LongBool;          // ,   Fs  Base 
        LChQnt:integer;            //   
        LChTbl:array[0..15]of cardinal;       //   
        Fs:double;                 //   
        Base:word;                 //   
        F_Base:double;                    //   F_Base=Fs/Base
        AcqTime:integer;           //    
        TbaseQnt:integer;              //   ,      
        ModuleInfo:TINFO_LTR51;
    end;
    pTLTR51=^TLTR51;              //   

    {$A+}

    {    var/out }
    Function LTR51_Init(out hnd: TLTR51):integer;   stdcall; overload;
    Function LTR51_Open(var hnd: TLTR51; net_addr : LongWord; net_port : Word;
                        csn: string; slot: integer; ttf_name: string): Integer; stdcall; overload;
    Function LTR51_IsOpened(var hnd: TLTR51):integer; stdcall; overload;
    Function LTR51_Close(var hnd: TLTR51):integer;stdcall; overload;
    Function LTR51_CreateLChannel(PhysChannel:integer; var HighThreshold: double;
                                  var LowThreshold: double; ThresholdRange:integer;
                                  EdgeMode:integer):LongWord;stdcall; overload;
    Function  LTR51_WriteEEPROM(var hnd: TLTR51; Address:integer; val:byte):integer; stdcall; overload;
    Function  LTR51_ReadEEPROM(var hnd: TLTR51; Address:integer; out val:byte):integer; stdcall; overload;
    Function  LTR51_Config(var hnd: TLTR51):integer; stdcall; overload;
    Function  LTR51_Start(var hnd: TLTR51):integer; stdcall; overload;
    Function  LTR51_Stop(var hnd: TLTR51):integer; stdcall; overload;
     //    
    Function  LTR51_Recv(var hnd: TLTR51; out data : array of LongWord;
                        out tmark : array of LongWord; size: LongWord; tout : LongWord): Integer; stdcall; overload;
    //   
    Function  LTR51_Recv(var hnd: TLTR51; out data : array of LongWord; size: LongWord;
                          tout : LongWord): Integer; stdcall; overload;

    Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                                out dest : array of LongWord; out Frequencies : array of Double;
                                var size: LongWord): LongInt; stdcall; overload;
    //   -      N  M
    Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                              out dest : array of LongWord;
                              var size: LongWord): LongInt; stdcall; overload;
    //   N  M -                                  
    Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                              out Frequencies : array of Double;
                              var size: LongWord): LongInt; stdcall; overload;


    Function  LTR51_GetThresholdVals(var hnd: TLTR51; LChNumber:integer;
                                     out HighThreshold: Double;
                                     out LowThreshold:  Double; ThresholdRange:integer):integer;stdcall; overload;
    Function  LTR51_CalcTimeOut     (var hnd: TLTR51; n:integer):Cardinal; stdcall; overload;

    Function  LTR51_GetErrorString  (err:integer):string; stdcall;

    {     Pointer }
    Function  LTR51_Init            (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_Open            (hnd:pTLTR51; net_addrDWORD:Cardinal; net_port:WORD; crate_snCHAR:POINTER; slot_num:integer; ttf_nameCHAR:PAnsiChar):integer;stdcall; overload;
    Function  LTR51_IsOpened        (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_Close           (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_WriteEEPROM     (hnd:pTLTR51; Address:integer; val:byte):integer; stdcall; overload;
    Function  LTR51_ReadEEPROM      (hnd:pTLTR51; Address:integer; valBYTE:Pointer):integer; stdcall; overload;
    Function  LTR51_CreateLChannel  (PhysChannel:integer; HighThresholdDOUBLE:Pointer; LowThresholdDOUBLE:Pointer; ThresholdRange:integer; EdgeMode:integer):Cardinal;stdcall; overload;
    Function  LTR51_Config          (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_Start           (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_Stop            (hnd:pTLTR51):integer; stdcall; overload;
    Function  LTR51_Recv            (hnd:pTLTR51; dataDWORD:Pointer; tmarkDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer; stdcall; overload;
    Function  LTR51_ProcessData     (hnd:pTLTR51; srcDWORD:Pointer; destDWORD:Pointer; FrequencyDOUBLE:Pointer; sizeDWORD:pointer):integer; stdcall; overload;
    Function  LTR51_GetThresholdVals(hnd:pTLTR51; LChNumber:integer; HighThresholdDOUBLE:Pointer; LowThresholdDOUBLE:pointer; ThresholdRange:integer):integer;stdcall; overload;
    Function  LTR51_CalcTimeOut     (hnd:pTLTR51; n:integer):Cardinal; stdcall; overload;

implementation
  Function LTR51_Init(out hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function _open(var hnd: TLTR51; net_addr : LongWord; net_port : Word; csn: PAnsiChar; slot: Integer; ttf_name : PAnsiChar) : Integer; stdcall; external 'ltr51api.dll' name 'LTR51_Open';
  Function LTR51_IsOpened(var hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function LTR51_Close(var hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function LTR51_WriteEEPROM(var hnd: TLTR51; Address:integer; val:byte):integer; stdcall; overload; external 'ltr51api.dll';
  Function LTR51_ReadEEPROM(var hnd: TLTR51; Address:integer; out val:byte):integer; stdcall; overload; external 'ltr51api.dll';  
  Function LTR51_CreateLChannel(PhysChannel:integer; var HighThreshold: double;
                               var LowThreshold: double; ThresholdRange:integer;
                               EdgeMode:integer):LongWord;stdcall; overload; external 'ltr51api.dll';
  Function  LTR51_Config(var hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function  LTR51_Start(var hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function  LTR51_Stop(var hnd: TLTR51):integer; stdcall; overload; external 'ltr51api.dll';
  Function _recv(var hnd: TLTR51; out data; out tmark; size: LongWord; tout : LongWord): Integer; stdcall;  external 'ltr51api.dll' name 'LTR51_Recv';
  Function _process_data(var hnd: TLTR51; var src; out dest; out Frequency;
                                var size: LongWord): LongInt; stdcall;  external 'ltr51api.dll' name 'LTR51_ProcessData';
  Function  LTR51_GetThresholdVals(var hnd: TLTR51; LChNumber:integer;
                                     out HighThreshold: Double;
                                     out LowThreshold:  Double; ThresholdRange:integer):integer;stdcall; overload; external 'ltr51api.dll';
  Function  LTR51_CalcTimeOut     (var hnd: TLTR51; n:integer):Cardinal; stdcall; overload; external 'ltr51api.dll';

  Function  LTR51_Init            (hnd:pTLTR51):integer; overload; external 'ltr51api.dll';
  Function  LTR51_Open            (hnd:pTLTR51; net_addrDWORD:Cardinal; net_port:WORD; crate_snCHAR:POINTER; slot_num:integer; ttf_nameCHAR:PAnsiChar):integer; overload; external 'ltr51api.dll';
  Function  LTR51_IsOpened        (hnd:pTLTR51):integer; overload; external 'ltr51api.dll';
  Function  LTR51_Close           (hnd:pTLTR51):integer; overload; external 'ltr51api.dll';
  Function  LTR51_WriteEEPROM     (hnd:pTLTR51; Address:integer; val:byte):integer;external 'ltr51api.dll';
  Function  LTR51_ReadEEPROM      (hnd:pTLTR51; Address:integer; valBYTE:Pointer):integer;external 'ltr51api.dll';
  Function  LTR51_CreateLChannel  (PhysChannel:integer; HighThresholdDOUBLE:Pointer; LowThresholdDOUBLE:Pointer; ThresholdRange:integer; EdgeMode:integer):Cardinal;external 'ltr51api.dll';
  Function  LTR51_Config          (hnd:pTLTR51):integer;external 'ltr51api.dll';
  Function  LTR51_Start           (hnd:pTLTR51):integer;external 'ltr51api.dll';
  Function  LTR51_Stop            (hnd:pTLTR51):integer;external 'ltr51api.dll';
  Function  LTR51_Recv            (hnd:pTLTR51; dataDWORD:Pointer; tmarkDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer;external 'ltr51api.dll';
  Function  LTR51_ProcessData     (hnd:pTLTR51; srcDWORD:Pointer; destDWORD:Pointer; FrequencyDOUBLE:Pointer; sizeDWORD:pointer):integer;external 'ltr51api.dll';
  Function  LTR51_GetThresholdVals(hnd:pTLTR51; LChNumber:integer; HighThresholdDOUBLE:Pointer; LowThresholdDOUBLE:pointer; ThresholdRange:integer):integer;external 'ltr51api.dll';
  Function  LTR51_CalcTimeOut     (hnd:pTLTR51; n:integer):Cardinal;external 'ltr51api.dll';

  Function _get_err_str(err : integer) : PAnsiChar; stdcall; external 'ltr51api.dll' name 'LTR51_GetErrorString';




  Function LTR51_Open(var hnd: TLTR51; net_addr : LongWord; net_port : Word;
                      csn: string; slot: Integer; ttf_name : string): Integer; stdcall; overload;
  begin
      LTR51_Open:=_open(hnd, net_addr, net_port, PAnsiChar(AnsiString(csn)), slot, PAnsiChar(AnsiString(ttf_name)));
  end;

  Function LTR51_Recv(var hnd: TLTR51; out data : array of LongWord; out tmark : array of LongWord; size: LongWord; tout : LongWord): Integer; stdcall;
  begin
    LTR51_Recv:=_recv(hnd, data, tmark, size, tout);
  end;

  Function LTR51_Recv(var hnd: TLTR51; out data : array of LongWord; size: LongWord; tout : LongWord): Integer; stdcall;
  begin
    LTR51_Recv:=_recv(hnd, data, PLongWord(nil)^, size, tout);
  end;

  Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                              out dest : array of LongWord; out Frequencies : array of Double;
                              var size: LongWord): LongInt; stdcall; overload;
  begin
    LTR51_ProcessData:=_process_data(hnd, src, dest, Frequencies, size);
  end;

  Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                              out dest : array of LongWord;
                              var size: LongWord): LongInt; stdcall; overload;
  begin
    LTR51_ProcessData:=_process_data(hnd, src, dest, PDouble(nil)^, size);
  end;

  Function  LTR51_ProcessData(var hnd: TLTR51; var src : array of LongWord;
                              out Frequencies : array of Double;
                              var size: LongWord): LongInt; stdcall; overload;
  begin
    LTR51_ProcessData:=_process_data(hnd, src, PLongWord(nil)^, Frequencies, size);
  end;


  Function LTR51_GetErrorString(err: Integer) : string; stdcall;
  begin
     LTR51_GetErrorString:=string(_get_err_str(err));
  end;
end.















