unit ltrapi;
interface
uses windows, SysUtils, ltrapitypes, ltrapidefine;

const
    LTR_OK                              =  0;  //   .
    LTR_ERROR_UNKNOWN                   = -1;  //  .
    LTR_ERROR_PARAMETRS                 = -2;  //   .
    LTR_ERROR_MEMORY_ALLOC              = -3;  //    .
    LTR_ERROR_OPEN_CHANNEL              = -4;  //      .
    LTR_ERROR_OPEN_SOCKET               = -5;  //   .
    LTR_ERROR_CHANNEL_CLOSED            = -6;  // .      .
    LTR_ERROR_SEND                      = -7;  //   .
    LTR_ERROR_RECV                      = -8;  //   .
    LTR_ERROR_EXECUTE                   = -9;  //    -.
    LTR_WARNING_MODULE_IN_USE           = -10; //        
                                               //   - 
    LTR_ERROR_NOT_CTRL_CHANNEL          = -11; //        CC_CONTROL
    LTR_ERROR_SRV_INVALID_CMD           = -12; //    
    LTR_ERROR_SRV_INVALID_CMD_PARAMS    = -13; //      
    LTR_ERROR_INVALID_CRATE             = -14; //    
    LTR_ERROR_EMPTY_SLOT                = -15; //     
    LTR_ERROR_UNSUP_CMD_FOR_SRV_CTL     = -16; //      
    LTR_ERROR_INVALID_IP_ENTRY          = -17; //     
    LTR_ERROR_NOT_IMPLEMENTED           = -18; //    

    LTR_ERROR_INVALID_MODULE_DESCR      = -40; //   
    LTR_ERROR_INVALID_MODULE_SLOT       = -41; //     
    LTR_ERROR_INVALID_MODULE_ID         = -42; //  ID-    
    LTR_ERROR_NO_RESET_RESPONSE         = -43; //     
    LTR_ERROR_SEND_INSUFFICIENT_DATA    = -44; //   ,  
    LTR_ERROR_RECV_INSUFFICIENT_DATA    = -45;
    LTR_ERROR_NO_CMD_RESPONSE           = -46; //     
    LTR_ERROR_INVALID_CMD_RESPONSE      = -47; //     
    LTR_ERROR_INVALID_RESP_PARITY       = -48; //      
    LTR_ERROR_INVALID_CMD_PARITY        = -49; //    
    LTR_ERROR_UNSUP_BY_FIRM_VER         = -50; //      
    LTR_ERROR_MODULE_STARTED            = -51; //   
    LTR_ERROR_MODULE_STOPPED            = -52; //  
    LTR_ERROR_RECV_OVERFLOW             = -53; //   
    LTR_ERROR_FIRM_FILE_OPEN            = -54; //    
    LTR_ERROR_FIRM_FILE_READ            = -55; //    
    LTR_ERROR_FIRM_FILE_FORMAT          = -56; //    
    LTR_ERROR_FPGA_LOAD_READY_TOUT      = -57; //       
    LTR_ERROR_FPGA_LOAD_DONE_TOUT       = -58; //        
    LTR_ERROR_FPGA_IS_NOT_LOADED        = -59; //    
    LTR_ERROR_FLASH_INVALID_ADDR        = -60; //   Flash-
    LTR_ERROR_FLASH_WAIT_RDY_TOUT       = -61; //     / Flash-
    LTR_ERROR_FIRSTFRAME_NOTFOUND       = -62; // First frame in card data stream not found
    LTR_ERROR_CARDSCONFIG_UNSUPPORTED   = -63;
    LTR_ERROR_FLASH_OP_FAILED           = -64; //    flash-
    LTR_ERROR_FLASH_NOT_PRESENT         = -65; // Flash-  
    LTR_ERROR_FLASH_UNSUPPORTED_ID      = -66; //    flash-
    LTR_ERROR_FLASH_UNALIGNED_ADDR      = -67; //   flash-
    LTR_ERROR_FLASH_VERIFY              = -68; //       flash-
    LTR_ERROR_FLASH_UNSUP_PAGE_SIZE     = -69; //     flash-
    LTR_ERROR_FLASH_INFO_NOT_PRESENT    = -70; //      Flash-
    LTR_ERROR_FLASH_INFO_UNSUP_FORMAT   = -71; //       Flash-
    LTR_ERROR_FLASH_SET_PROTECTION      = -72; //     Flash-
    LTR_ERROR_FPGA_NO_POWER             = -73; //    
    LTR_ERROR_FPGA_INVALID_STATE        = -74; //     
    LTR_ERROR_FPGA_ENABLE               = -75; //       
    LTR_ERROR_FPGA_AUTOLOAD_TOUT        = -76; //      
    LTR_ERROR_PROCDATA_UNALIGNED        = -77; //       
    LTR_ERROR_PROCDATA_CNTR             = -78; //     
    LTR_ERROR_PROCDATA_CHNUM            = -79; //      
    LTR_ERROR_PROCDATA_WORD_SEQ         = -80; //      


type
//     ,    
en_LTR_UserIoCfg=(LTR_USERIO_DIGIN1    =1,//       DIGIN1
                  LTR_USERIO_DIGIN2   = 2,    //       DIGIN2
                  LTR_USERIO_DIGOUT   = 0,    //    ( . en_LTR_DigOutCfg)
                  LTR_USERIO_DEFAULT  = LTR_USERIO_DIGOUT);
//     DIGOUTx
en_LTR_DigOutCfg=(
    LTR_DIGOUT_CONST0   = $00, //    "0"
    LTR_DIGOUT_CONST1   = $01, //    "1"
    LTR_DIGOUT_USERIO0  = $02, //     userio0 (PF1  . 0, PF1  . 1)
    LTR_DIGOUT_USERIO1  = $03, //     userio1 (PG13)
    LTR_DIGOUT_DIGIN1   = $04, //     DIGIN1
    LTR_DIGOUT_DIGIN2   = $05, //     DIGIN2
    LTR_DIGOUT_START    = $06, //     ""
    LTR_DIGOUT_SECOND   = $07, //     ""
    LTR_DIGOUT_IRIG     = $08, //     IRIG (digout1: , digout2: )
    LTR_DIGOUT_DEFAULT  = LTR_DIGOUT_CONST0
    );
//     ""  ""
en_LTR_MarkMode=(
    LTR_MARK_OFF                = $00, //  
    LTR_MARK_EXT_DIGIN1_RISE    = $01, //    DIGIN1
    LTR_MARK_EXT_DIGIN1_FALL    = $02, //    DIGIN1
    LTR_MARK_EXT_DIGIN2_RISE    = $03, //    DIGIN2
    LTR_MARK_EXT_DIGIN2_FALL    = $04, //    DIGIN2
    LTR_MARK_INTERNAL           = $05, //   

    LTR_MARK_NAMUR1_LO2HI       = 8,   //   NAMUR1 (START_IN),  
    LTR_MARK_NAMUR1_HI2LO       = 9,   //   NAMUR1 (START_IN),  
    LTR_MARK_NAMUR2_LO2HI       = 10,  //   NAMUR2 (M1S_IN),  
    LTR_MARK_NAMUR2_HI2LO       = 11,  //   NAMUR2 (M1S_IN),  

    {   -     IRIG-B006
       IRIG      "",  ""  }
    LTR_MARK_SEC_IRIGB_DIGIN1   = 16,   //   DIGIN1,  
    LTR_MARK_SEC_IRIGB_nDIGIN1  = 17,   //   DIGIN1,  
    LTR_MARK_SEC_IRIGB_DIGIN2   = 18,   //   DIGIN2,  
    LTR_MARK_SEC_IRIGB_nDIGIN2  = 19    //   DIGIN2,  
    );

{$A4}
TLTR=record
    saddr:Cardinal;                     //   
    sport:word;                         //   
    csn:SERNUMtext;                     //   
    cc:WORD;                            //   
    flags:Cardinal;                     //   
    tmark:Cardinal;                     //    
    internal:Pointer;                   //   
end;
pTLTR = ^TLTR;
TLTR_CONFIG=record
     userio:array[0..3]of WORD;
     digout:array[0..1]of WORD;
     digout_en:WORD;
end;

Type t_crate_ipentry_array = array[0..0] of TIPCRATE_ENTRY;
Type p_crate_ipentry_array = ^t_crate_ipentry_array;

{$A+}

//    
Function LTR__GenericCtlFunc(
        TLTR:Pointer;                       //  LTR
        request_buf:Pointer;                //   
        request_size:Cardinal;              //   ( )
        reply_buf:Pointer;                  //    ( NULL)
        reply_size:Cardinal;                //   ( )
        ack_error_code:integer;             //  ,  ack  GOOD (0 =   ack)
        timeout:Cardinal                   // , 
    ):integer; stdcall;

//   



Function LTR_Init(ltr:pTLTR):integer;  stdcall; overload;
Function LTR_Open(ltr:pTLTR):integer;  stdcall; overload;
Function LTR_Close(ltr:pTLTR):integer;  stdcall; overload;
Function LTR_IsOpened(ltr:pTLTR):integer;  stdcall; overload;
Function LTR_Recv(ltr:pTLTR; dataDWORD:Pointer; tmarkDWORD:POINTER; size:Cardinal; timeout:Cardinal):integer;  stdcall;
Function LTR_Send(ltr:pTLTR; dataDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer;  stdcall;
Function LTR_GetCrates(ltr:pTLTR; csnBYTE:Pointer):integer;  stdcall; overload;
Function LTR_GetCrateModules(ltr:pTLTR; midWORD:Pointer):integer;  stdcall; overload;

Function LTR_GetCrateRawData(ltr:pTLTR; dataDWORD:Pointer; tmarkDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer;  stdcall;
Function LTR_GetErrorString(error:integer):string;  stdcall;

Function    LTR_GetCrateInfo(ltr:pTLTR; CrateInfoTCRATE_INFO:Pointer):integer; stdcall; overload;
Function    LTR_Config(ltr:pTLTR; confTLTR_CONFIG:Pointer):integer; stdcall; overload;
Function    LTR_StartSecondMark(ltr:pTLTR; mode:en_LTR_MarkMode):integer; stdcall; overload;
Function    LTR_StopSecondMark(ltr:pTLTR):integer; stdcall;  overload;
Function    LTR_MakeStartMark(ltr:pTLTR; mode:en_LTR_MarkMode):integer; stdcall; overload;
//Function    LTR_GetListOfIPCrates(ltr:pTLTR; max_entries:DWORD; ip_net:DWORD; ip_mask:DWORD; entries_foundDWORD:Pointer; entries_returnedDWORD:Pointer; var info_array:TIPCRATE_ENTRY):integer; stdcall;
Function    LTR_AddIPCrate(ltr:pTLTR; ip_addr:DWORD; flags:DWORD; permanent:BOOL):integer; stdcall; overload;
Function    LTR_DeleteIPCrate(ltr:pTLTR; ip_addr:DWORD; permanent:BOOL):integer; stdcall; overload;
Function    LTR_ConnectIPCrate(ltr:pTLTR; ip_addr:DWORD):integer; stdcall; overload;
Function    LTR_DisconnectIPCrate(ltr:pTLTR; ip_addr:DWORD):integer; stdcall; overload;
Function    LTR_ConnectAllAutoIPCrates(ltr:pTLTR):integer; stdcall; overload;
Function    LTR_DisconnectAllIPCrates(ltr:pTLTR):integer; stdcall; overload;
Function    LTR_SetIPCrateFlags(ltr:pTLTR; ip_addr:DWORD; new_flags:DWORD; permanent:BOOL):integer; stdcall; overload;
Function    LTR_GetLogLevel(ltr:pTLTR; levelINT:Pointer):integer; stdcall; overload;
Function    LTR_SetLogLevel(ltr:pTLTR; level:integer;  permanent:BOOL):integer; stdcall; overload;
Function    LTR_ServerRestart(ltr:pTLTR):integer; stdcall; overload;
Function    LTR_ServerShutdown(ltr:pTLTR):integer; stdcall; overload;
Function    LTR_SetTimeout(ltr:pTLTR; ms:Cardinal):integer; stdcall;  overload;
Function    LTR_SetServerProcessPriority(ltr:pTLTR; Priority:Cardinal):integer;  stdcall; overload;
Function    LTR_GetServerProcessPriority(ltr:pTLTR; Priority:Pointer):integer; stdcall;  overload;
Function    LTR_GetServerVersion(ltr:pTLTR; version:Pointer):integer; stdcall;  overload;
Function    LTR_GetLastUnixTimeMark(ltr:pTLTR; unixtime:Pointer):integer;stdcall;  overload;

Function    LTR_GetIPCrateDiscoveryMode(ltr:pTLTR; enabledBOOL:Pointer; autoconnectBOOL:Pointer):integer; stdcall;
Function    LTR_SetIPCrateDiscoveryMode(ltr:pTLTR; enabled:BOOL; autoconnect:BOOL; permanent:BOOL):integer; stdcall;


Function LTR_Init(out ltr: TLTR):integer;  stdcall; overload;
Function LTR_Open(var ltr: TLTR):integer;  stdcall; overload;
Function LTR_Close(var ltr: TLTR):integer;  stdcall; overload;
Function LTR_IsOpened(var ltr: TLTR):integer;  stdcall; overload;
//       TLTR (  )
Procedure LTR_FillSerial(var ltr: TLTR; csn : string); stdcall;

Function LTR_GetCrates(var ltr: TLTR; var csn: array of string; out crates_cnt: Integer):integer;  stdcall; overload;

Function LTR_GetCrateModules(var ltr: TLTR; var mids: array of Word):integer;  stdcall; overload;

Function LTR_GetCrateInfo(var ltr:TLTR; out CrateInfo:TCRATE_INFO):integer; stdcall; overload;
Function LTR_Config(var ltr:TLTR; var conf : TLTR_CONFIG):integer; stdcall; overload;
Function LTR_StartSecondMark(var ltr:TLTR; mode:en_LTR_MarkMode):integer; stdcall; overload;
Function LTR_StopSecondMark(var ltr:TLTR):integer; stdcall;  overload;
Function LTR_MakeStartMark(var ltr:TLTR; mode:en_LTR_MarkMode):integer; stdcall; overload;

Function LTR_AddIPCrate(var ltr: TLTR; ip_addr: Cardinal; flags: Cardinal; permanent:LongBool):integer; stdcall; overload;
Function LTR_DeleteIPCrate(var ltr: TLTR; ip_addr: Cardinal; permanent:LongBool):integer; stdcall; overload;
Function LTR_ConnectIPCrate(var ltr: TLTR; ip_addr:Cardinal):integer; stdcall; overload;
Function LTR_DisconnectIPCrate(var ltr: TLTR; ip_addr:Cardinal):integer; stdcall; overload;
Function LTR_ConnectAllAutoIPCrates(var ltr: TLTR):integer; stdcall; overload;
Function LTR_DisconnectAllIPCrates(var ltr: TLTR):integer; stdcall; overload;
Function LTR_SetIPCrateFlags(var ltr: TLTR; ip_addr:Cardinal; new_flags:Cardinal; permanent:LongBool):integer; stdcall; overload;

Function LTR_GetListOfIPCrates(var ltr: TLTR; ip_net : Cardinal; ip_mask:Cardinal;
                               out entries_found: Cardinal;
                               out entries_returned: Cardinal;
                               out info_array: array of TIPCRATE_ENTRY):integer;  stdcall;

Function LTR_GetLogLevel(var ltr: TLTR; out level:integer):integer; stdcall; overload;
Function LTR_SetLogLevel(var ltr: TLTR; level:integer;  permanent: LongBool):integer; stdcall; overload;
Function LTR_ServerRestart(var ltr: TLTR):integer; stdcall; overload;
Function LTR_ServerShutdown(var ltr: TLTR):integer; stdcall; overload;
Function LTR_SetTimeout(var ltr: TLTR; ms:Cardinal):integer; stdcall;  overload;
Function LTR_SetServerProcessPriority(var ltr: TLTR; Priority:Cardinal):integer;  stdcall; overload;
Function LTR_GetServerProcessPriority(var ltr: TLTR; out Priority:Cardinal):integer; stdcall;  overload;
Function LTR_GetServerVersion(var ltr: TLTR; out version:Cardinal):integer; stdcall;  overload;
Function LTR_GetLastUnixTimeMark(var ltr: TLTR; out unixtime:UInt64):integer;stdcall;  overload;


Function LTR_CrateGetArray(var ltr: TLTR; address : Cardinal; out buf: array of Byte; size : Cardinal): Integer; stdcall;
Function LTR_CratePutArray(var ltr: TLTR; address : Cardinal; const buf: array of Byte; size : Cardinal): Integer; stdcall;

Implementation
  Type t_crate_serial_array = array[0..CRATE_MAX-1] of array[0..SERIAL_NUMBER_SIZE-1] of AnsiChar;
  Type p_crate_serial_array = ^t_crate_serial_array;
  Type t_crate_mids_array = array[0..MODULE_MAX-1] of Word;
  Type p_crate_mids_array = ^t_crate_mids_array;



  Function LTR__GenericCtlFunc(TLTR:Pointer;request_buf:Pointer;request_size:Cardinal;reply_buf:Pointer;reply_size:Cardinal;ack_error_code:integer;timeout:Cardinal):integer;external 'ltrapi.dll';
  Function LTR_Init(ltr:pTLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_Open(ltr:pTLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_Close(ltr:pTLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_IsOpened(ltr:pTLTR):integer; stdcall;  external 'ltrapi.dll';
  Function LTR_Recv(ltr:pTLTR; dataDWORD:Pointer; tmarkDWORD:POINTER; size:Cardinal; timeout:Cardinal):integer;external 'ltrapi.dll';
  Function LTR_Send(ltr:pTLTR; dataDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer;external 'ltrapi.dll';
  Function LTR_GetCrates(ltr:pTLTR; csnBYTE:Pointer):integer;external 'ltrapi.dll';
  Function LTR_GetCrateModules(ltr:pTLTR; midWORD:Pointer):integer;external 'ltrapi.dll';
  Function LTR_SetServerProcessPriority(ltr:pTLTR; Priority:Cardinal):integer;external 'ltrapi.dll';
  Function LTR_GetCrateRawData(ltr:pTLTR; dataDWORD:Pointer; tmarkDWORD:Pointer; size:Cardinal; timeout:Cardinal):integer;external 'ltrapi.dll';
  //Function LTR_GetErrorString(error:integer):string; external 'ltrapi.dll';
  Function _get_err_str(err : integer) : PAnsiChar; stdcall; external 'ltrapi.dll' name 'LTR_GetErrorString';

  Function LTR_GetCrateInfo(ltr:pTLTR; CrateInfoTCRATE_INFO:Pointer):integer; external 'ltrapi.dll';
  Function LTR_Config(ltr:pTLTR; confTLTR_CONFIG:Pointer):integer; external 'ltrapi.dll';
  Function LTR_StartSecondMark(ltr:pTLTR; mode:en_LTR_MarkMode):integer; external 'ltrapi.dll';
  Function LTR_StopSecondMark(ltr:pTLTR):integer; external 'ltrapi.dll';
  Function LTR_MakeStartMark(ltr:pTLTR; mode:en_LTR_MarkMode):integer; external 'ltrapi.dll';
  //Function LTR_GetListOfIPCrates(ltr:pTLTR; max_entries:DWORD; ip_net:DWORD; ip_mask:DWORD; entries_foundDWORD:Pointer; entries_returnedDWORD:Pointer; var info_array:TIPCRATE_ENTRY):integer; external 'ltrapi.dll';



  Function LTR_AddIPCrate(ltr:pTLTR; ip_addr:DWORD; flags:DWORD; permanent:BOOL):integer; external 'ltrapi.dll';
  Function LTR_DeleteIPCrate(ltr:pTLTR; ip_addr:DWORD; permanent:BOOL):integer; external 'ltrapi.dll';
  Function LTR_ConnectIPCrate(ltr:pTLTR; ip_addr:DWORD):integer; external 'ltrapi.dll';
  Function LTR_DisconnectIPCrate(ltr:pTLTR; ip_addr:DWORD):integer; external 'ltrapi.dll';
  Function LTR_ConnectAllAutoIPCrates(ltr:pTLTR):integer; external 'ltrapi.dll';
  Function LTR_DisconnectAllIPCrates(ltr:pTLTR):integer; external 'ltrapi.dll';
  Function LTR_SetIPCrateFlags(ltr:pTLTR; ip_addr:DWORD; new_flags:DWORD; permanent:BOOL):integer; external 'ltrapi.dll';
  Function LTR_GetIPCrateDiscoveryMode(ltr:pTLTR; enabledBOOL:Pointer; autoconnectBOOL:Pointer):integer; external 'ltrapi.dll';
  Function LTR_SetIPCrateDiscoveryMode(ltr:pTLTR; enabled:BOOL; autoconnect:BOOL; permanent:BOOL):integer; external 'ltrapi.dll';
  Function LTR_GetLogLevel(ltr:pTLTR; levelINT:Pointer):integer; external 'ltrapi.dll';
  Function LTR_SetLogLevel(ltr:pTLTR; level:integer;  permanent:BOOL):integer; external 'ltrapi.dll';
  Function LTR_ServerRestart(ltr:pTLTR):integer; external 'ltrapi.dll';
  Function LTR_ServerShutdown(ltr:pTLTR):integer; external 'ltrapi.dll';
  Function LTR_SetTimeout(ltr:pTLTR; ms:Cardinal):integer; external 'ltrapi.dll';
  Function LTR_GetServerProcessPriority(ltr:pTLTR; Priority:Pointer):integer; external 'ltrapi.dll';
  Function LTR_GetServerVersion(ltr:pTLTR; version:Pointer):integer; external 'ltrapi.dll';
  Function LTR_GetLastUnixTimeMark(ltr:pTLTR; unixtime:Pointer):integer; external 'ltrapi.dll';






  Function LTR_Init(out ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_Open(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_Close(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_IsOpened(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function priv_GetCrates(var ltr: TLTR; csn: p_crate_serial_array): Integer; stdcall; external 'ltrapi.dll' name 'LTR_GetCrates';
  Function priv_GetCrateModules(var ltr: TLTR; mids: p_crate_mids_array):integer;  stdcall; external 'ltrapi.dll' name 'LTR_GetCrateModules';

  Function LTR_GetCrateInfo(var ltr:TLTR; out CrateInfo:TCRATE_INFO):integer; stdcall; external 'ltrapi.dll';
  Function LTR_Config(var ltr:TLTR; var conf : TLTR_CONFIG):integer; stdcall; external 'ltrapi.dll';
  Function LTR_StartSecondMark(var ltr:TLTR; mode:en_LTR_MarkMode):integer; stdcall; external 'ltrapi.dll';
  Function LTR_StopSecondMark(var ltr:TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_MakeStartMark(var ltr:TLTR; mode:en_LTR_MarkMode):integer; stdcall;  external 'ltrapi.dll';

  Function priv_GetListOfIPCrates(var ltr: TLTR; max_entries:Cardinal; ip_net:Cardinal; ip_mask:Cardinal; out entries_found:Cardinal; out entries_returned:DWORD; info_array:p_crate_ipentry_array):integer;stdcall; external 'ltrapi.dll' name 'LTR_GetListOfIPCrates';
  Function LTR_AddIPCrate(var ltr: TLTR; ip_addr: Cardinal; flags: Cardinal; permanent:LongBool):integer; stdcall; external 'ltrapi.dll';
  Function LTR_DeleteIPCrate(var ltr: TLTR; ip_addr: Cardinal; permanent:LongBool):integer; stdcall; external 'ltrapi.dll';
  Function LTR_ConnectIPCrate(var ltr: TLTR; ip_addr:Cardinal):integer; stdcall; external 'ltrapi.dll';
  Function LTR_DisconnectIPCrate(var ltr: TLTR; ip_addr:Cardinal):integer; stdcall; external 'ltrapi.dll';
  Function LTR_ConnectAllAutoIPCrates(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_DisconnectAllIPCrates(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_SetIPCrateFlags(var ltr: TLTR; ip_addr:Cardinal; new_flags:Cardinal; permanent:LongBool):integer; stdcall; external 'ltrapi.dll';

  Function LTR_GetLogLevel(var ltr: TLTR; out level:integer):integer; stdcall; external 'ltrapi.dll';
  Function LTR_SetLogLevel(var ltr: TLTR; level:integer;  permanent: LongBool):integer; stdcall; external 'ltrapi.dll';
  Function LTR_ServerRestart(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_ServerShutdown(var ltr: TLTR):integer; stdcall; external 'ltrapi.dll';
  Function LTR_SetTimeout(var ltr: TLTR; ms:Cardinal):integer; stdcall;  external 'ltrapi.dll';
  Function LTR_SetServerProcessPriority(var ltr: TLTR; Priority:Cardinal):integer;  stdcall; external 'ltrapi.dll';
  Function LTR_GetServerProcessPriority(var ltr: TLTR; out Priority:Cardinal):integer; stdcall;  external 'ltrapi.dll';
  Function LTR_GetServerVersion(var ltr: TLTR; out version:Cardinal):integer; stdcall;  external 'ltrapi.dll';
  Function LTR_GetLastUnixTimeMark(var ltr: TLTR; out unixtime:UInt64):integer;stdcall;  external 'ltrapi.dll';


  Function priv_CrateGetArray(var ltr: TLTR; address : Cardinal; out buf; size : Cardinal): Integer; stdcall; external 'ltrapi.dll' name 'LTR_CrateGetArray';
  Function priv_CratePutArray(var ltr: TLTR; address : Cardinal; const buf; size : Cardinal): Integer; stdcall; external 'ltrapi.dll' name 'LTR_CratePutArray';


  Procedure LTR_FillSerial(var ltr: TLTR; csn : string); stdcall;
  var
    i: Integer;
  begin
     for i:=0 to SERIAL_NUMBER_SIZE-1 do     //   
     begin
       if i < Length(csn) then
       begin
          ltr.csn[i] := AnsiChar(csn[i+1]);
       end
       else
       begin
          ltr.csn[i] := AnsiChar(0);
       end;
     end;
  end;





  Function LTR_GetCrates(var ltr: TLTR; var csn: array of string; out crates_cnt: Integer):integer; stdcall;
  var
    serial_array: p_crate_serial_array;
    res,i: Integer;
  begin
    crates_cnt:=0;
    serial_array:=GetMemory(CRATE_MAX*SERIAL_NUMBER_SIZE);
    res:= priv_GetCrates(ltr, serial_array);
    if res = LTR_OK then
    begin
        for i:=0 to CRATE_MAX-1 do
        begin
            if (serial_array[i][0]<>'') then   //     
            begin
                if Length(csn) > crates_cnt then
                begin
                  csn[crates_cnt] := string(serial_array[i]);
                end;
                crates_cnt:=crates_cnt+1;
            end;
        end;
    end;
    FreeMemory(serial_array);
    LTR_GetCrates := res;
  end;

  Function LTR_GetCrateModules(var ltr: TLTR; var mids: array of Word):integer;  stdcall; overload;
  var
    mid_array: p_crate_mids_array;
    res,i: Integer;
  begin
    mid_array:=GetMemory(MODULE_MAX*2);
    res:= priv_GetCrateModules(ltr, mid_array);
    if res = LTR_OK then
    begin
        for i:=0 to Length(mids)-1 do
        begin
            if (i < MODULE_MAX) then   //     
            begin
                mids[i]:=mid_array[i];
            end
            else
            begin
                mids[i]:=MID_EMPTY;
            end;
        end;
    end;
    FreeMemory(mid_array);
    LTR_GetCrateModules := res;
  end;


  Function LTR_GetListOfIPCrates(var ltr: TLTR; ip_net : Cardinal; ip_mask:Cardinal;
                                 out entries_found: Cardinal;
                                 out entries_returned: Cardinal;
                                 out info_array: array of TIPCRATE_ENTRY):integer;  stdcall;
  var
    ip_arr: p_crate_ipentry_array;
    res, i: Integer;
  begin
    if Length(info_array) > 0 then
    begin
      ip_arr:=GetMemory(Length(info_array)*SizeOf(TIPCRATE_ENTRY));
      res:= priv_GetListOfIPCrates(ltr, Length(info_array),  ip_net, ip_mask,
                                  entries_found, entries_returned, ip_arr);
      if res = LTR_OK then
      begin
        for i:=0 to entries_returned-1 do
          info_array[i] := ip_arr[i];
      end;
      FreeMemory(ip_arr);
    end
    else
    begin
      res:=priv_GetListOfIPCrates(ltr, 0,  ip_net, ip_mask, entries_found,
                                  entries_returned, nil);
    end;

    LTR_GetListOfIPCrates:=res;
  end;



  Function LTR_GetErrorString(error:integer):string; stdcall;
  begin
    LTR_GetErrorString:= string(_get_err_str(error));
  end;

  Function LTR_CrateGetArray(var ltr: TLTR; address : Cardinal; out buf: array of Byte; size : Cardinal): Integer; stdcall;
  begin
     LTR_CrateGetArray := priv_CrateGetArray(ltr, address, buf, size);
  end;

  Function LTR_CratePutArray(var ltr: TLTR; address : Cardinal; const buf: array of Byte; size : Cardinal): Integer; stdcall;
  begin
    LTR_CratePutArray := priv_CratePutArray(ltr, address, buf, size);
  end;

end.


